/*
 *
 *      V 4 L 2   D R I V E R   H E L P E R   A P I
 *
 * Moved from videodev2.h
 *
 *      Some commonly needed functions for drivers (v4l2-common.o module)
 */

#ifndef _LINUX_V4L2_DEV_H
#define _LINUX_V4L2_DEV_H

#include <sys/stddef.h>		/* NULL */
#include <sys/time.h>		/* some hidden struct... */

struct video_device;
struct file;

// #include <linux/fs.h>	/* struct file */
// struct class_device_attribute;
#include <linux/device.h>	/* full struct device */
#include <linux/poll.h>

/* 32 Bits compatibility layer for 64 bits processors */
long v4l_compat_ioctl32(struct file *file, unsigned int cmd,
                                unsigned long arg);

void video_device_remove_file(struct video_device *vfd, 
                         struct class_device_attribute *attr);

/*  Compatibility layer interface  --  v4l1-compat module */
typedef int (*v4l2_kioctl)(struct inode *inode, struct file *file,
                           unsigned int cmd, void *arg);
#ifdef CONFIG_VIDEO_V4L1_COMPAT
int v4l_compat_translate_ioctl(struct inode *inode, struct file *file,
                               int cmd, void *arg, v4l2_kioctl driver_ioctl);
#else
#define v4l_compat_translate_ioctl(inode,file,cmd,arg,ioctl) -EINVAL
#endif

#endif /* _LINUX_V4L2_DEV_H */
